/**
 * NOTE: This class is auto generated by the swagger code generator program (2.4.21).
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */
package mx.sidlors.dvd.rental.api;

import  mx.sidlors.dvd.rental.model.Address;
import io.swagger.annotations.*;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestPart;
import org.springframework.web.multipart.MultipartFile;

import javax.validation.Valid;
import javax.validation.constraints.*;
import java.util.List;
@javax.annotation.Generated(value = "io.swagger.codegen.languages.SpringCodegen", date = "2021-07-21T02:33:33.560Z")

@Validated
@Api(value = "address", description = "the address API")
@RequestMapping(value = "")
public interface AddressApi {

    @ApiOperation(value = "", nickname = "addressDelete", notes = "", tags={ "address", })
    @ApiResponses(value = { 
        @ApiResponse(code = 204, message = "No Content") })
    @RequestMapping(value = "/address",
        produces = { "application/json", "application/vnd.pgrst.object+json", "text/csv" }, 
        consumes = { "application/json", "application/vnd.pgrst.object+json", "text/csv" },
        method = RequestMethod.DELETE)
    ResponseEntity<Void> addressDelete(@ApiParam(value = "") @Valid @RequestParam(value = "address_id", required = false) String addressId,@ApiParam(value = "") @Valid @RequestParam(value = "address", required = false) String address,@ApiParam(value = "") @Valid @RequestParam(value = "address2", required = false) String address2,@ApiParam(value = "") @Valid @RequestParam(value = "district", required = false) String district,@ApiParam(value = "") @Valid @RequestParam(value = "city_id", required = false) String cityId,@ApiParam(value = "") @Valid @RequestParam(value = "postal_code", required = false) String postalCode,@ApiParam(value = "") @Valid @RequestParam(value = "phone", required = false) String phone,@ApiParam(value = "") @Valid @RequestParam(value = "last_update", required = false) String lastUpdate,@ApiParam(value = "Preference" , allowableValues="return=representation, return=minimal, return=none") @RequestHeader(value="Prefer", required=false) String prefer);


    @ApiOperation(value = "", nickname = "addressGet", notes = "", response = Address.class, responseContainer = "List", tags={ "address", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "OK", response = Address.class, responseContainer = "List"),
        @ApiResponse(code = 206, message = "Partial Content") })
    @RequestMapping(value = "/address",
        produces = { "application/json", "application/vnd.pgrst.object+json", "text/csv" }, 
        consumes = { "application/json", "application/vnd.pgrst.object+json", "text/csv" },
        method = RequestMethod.GET)
    ResponseEntity<List<Address>> addressGet(@ApiParam(value = "") @Valid @RequestParam(value = "address_id", required = false) String addressId,@ApiParam(value = "") @Valid @RequestParam(value = "address", required = false) String address,@ApiParam(value = "") @Valid @RequestParam(value = "address2", required = false) String address2,@ApiParam(value = "") @Valid @RequestParam(value = "district", required = false) String district,@ApiParam(value = "") @Valid @RequestParam(value = "city_id", required = false) String cityId,@ApiParam(value = "") @Valid @RequestParam(value = "postal_code", required = false) String postalCode,@ApiParam(value = "") @Valid @RequestParam(value = "phone", required = false) String phone,@ApiParam(value = "") @Valid @RequestParam(value = "last_update", required = false) String lastUpdate,@ApiParam(value = "Filtering Columns") @Valid @RequestParam(value = "select", required = false) String select,@ApiParam(value = "Ordering") @Valid @RequestParam(value = "order", required = false) String order,@ApiParam(value = "Limiting and Pagination" ) @RequestHeader(value="Range", required=false) String range,@ApiParam(value = "Limiting and Pagination" , defaultValue="items") @RequestHeader(value="Range-Unit", required=false) String rangeUnit,@ApiParam(value = "Limiting and Pagination") @Valid @RequestParam(value = "offset", required = false) String offset,@ApiParam(value = "Limiting and Pagination") @Valid @RequestParam(value = "limit", required = false) String limit,@ApiParam(value = "Preference" , allowableValues="count=none") @RequestHeader(value="Prefer", required=false) String prefer);


    @ApiOperation(value = "", nickname = "addressPatch", notes = "", tags={ "address", })
    @ApiResponses(value = { 
        @ApiResponse(code = 204, message = "No Content") })
    @RequestMapping(value = "/address",
        produces = { "application/json", "application/vnd.pgrst.object+json", "text/csv" }, 
        consumes = { "application/json", "application/vnd.pgrst.object+json", "text/csv" },
        method = RequestMethod.PATCH)
    ResponseEntity<Void> addressPatch(@ApiParam(value = "") @Valid @RequestParam(value = "address_id", required = false) String addressId,@ApiParam(value = "address"  )  @Valid @RequestBody Address address,@ApiParam(value = "") @Valid @RequestParam(value = "address2", required = false) String address2,@ApiParam(value = "") @Valid @RequestParam(value = "district", required = false) String district,@ApiParam(value = "") @Valid @RequestParam(value = "city_id", required = false) String cityId,@ApiParam(value = "") @Valid @RequestParam(value = "postal_code", required = false) String postalCode,@ApiParam(value = "") @Valid @RequestParam(value = "phone", required = false) String phone,@ApiParam(value = "") @Valid @RequestParam(value = "last_update", required = false) String lastUpdate,@ApiParam(value = "Preference" , allowableValues="return=representation, return=minimal, return=none") @RequestHeader(value="Prefer", required=false) String prefer);


    @ApiOperation(value = "", nickname = "addressPost", notes = "", tags={ "address", })
    @ApiResponses(value = { 
        @ApiResponse(code = 201, message = "Created") })
    @RequestMapping(value = "/address",
        produces = { "application/json", "application/vnd.pgrst.object+json", "text/csv" }, 
        consumes = { "application/json", "application/vnd.pgrst.object+json", "text/csv" },
        method = RequestMethod.POST)
    ResponseEntity<Void> addressPost(@ApiParam(value = "address"  )  @Valid @RequestBody Address address,@ApiParam(value = "Filtering Columns") @Valid @RequestParam(value = "select", required = false) String select,@ApiParam(value = "Preference" , allowableValues="return=representation, return=minimal, return=none") @RequestHeader(value="Prefer", required=false) String prefer);

}
